import 'package:serializer_interface/serializer_interface.dart';

class SerializationException<T> implements Exception {
  final dynamic message;
  final JsonSerializer<T>? serializer;

  SerializationException.fromJson(Map<String, dynamic>? json, {this.serializer})
      : message = "Failed to convert json ($json) to model";

  SerializationException.toJson(T model, {this.serializer})
      : message = "Failed to convert model ($model) to model";

  @override
  String toString() {
    Object? message = this.message;
    if (message == null) return "Exception";
    return "Exception: $message. Serializer: $serializer";
  }
}
